Index: trunk/kernel/kern/thread.h
===================================================================
--- trunk/kernel/kern/thread.h	(revision 690)
+++ trunk/kernel/kern/thread.h	(revision 1)
@@ -300,177 +276,141 @@
 error_t thread_kernel_create( thread_t     ** new_thread,
                               thread_type_t   type,
-                              void          * func,
+                              void          * func, 
                               void          * args,
                               lid_t           core_lid );
 
 /***************************************************************************************
- * This function is called by the kernel_init() function to initialize the IDLE thread
- * descriptor from arguments values.
- * The THREAD_BLOCKED_GLOBAL bit is set, and the thread must be activated to start.
- * It returns a kernel panic if failure.
- ***************************************************************************************
- * @ thread   : pointer on existing thread descriptor.
- * @ type     : kernel thread type.
- * @ func     : pointer on function.
- * @ args     : function arguments.
- * @ core_lid : local core index.
- **************************************************************************************/
-void thread_idle_init( thread_t      * thread,
-                       thread_type_t   type,
-                       void          * func,
-                       void          * args,
-                       lid_t           core_lid );
-
-/***************************************************************************************
- * This low-level function is called by the sched_handle_signals() function when a
- * thread is marked for delete. It removes the thread identified by the <thread>
- * argument from the process th_tbl[], and releases all physical memory allocated for 
- * this. This includes the thread descriptor itself, the associated CPU and FPU context,
- * and the physical memory allocated for an user thread stack.
- * This function does not remove the thread from the scheduler, as this is done by
- * the scheduler itself.
- ***************************************************************************************
- * @ thread  : pointer on the thread descriptor to release.
- * @ return the number of threads registered in the process th_tbl[] before deletion.
- **************************************************************************************/
-uint32_t thread_destroy( thread_t * thread );
-
-/***************************************************************************************
- * This function defines the code of the thread executed by all cores after kernel_init,
- * or when no other thread is runnable for a given core.
- * It enter and infinite loop in wich:
- * - it unmask the IRQs
- * - it optionally calls the hal_core_sleep() function to reduce the power consumption
- *   (this behavior is controlled by the CONFIG_THREAD_IDLE_MODE_SLEEP flag).
- * - it call the sched_yield() function to find another runnable thread.
- *
- * TODO: In the TSAR architecture the hal_core_sleep() function forces the core to
- * low-power mode. Any IRQ will force the core to exit this low-power mode, but no ISR
- * is executed. We must analyse if we have the same behaviour for I86 architectures...
- **************************************************************************************/
-void thread_idle_func( void );
-
-/***************************************************************************************
- * This function is used by a "blocker" thread running in the same cluster as a "target"
- * thread to request the scheduler of the target thread to acknowledge that the target
- * thread is blocked and not running, at the next context switch.
- * This function executes atomically the following actions :
- * - it set the request_pending boolean in the target scheduler descriptor.
- * - it set the REQ_ACK flag in the "flags" field of the target thread descriptor.
- * - It registers the responses counter pointer in the target thread descriptor.
- * The request_pending flag is handled as a set/reset flip-flop by the "blocker" thread
- * and by the "target" scheduler. 
- ***************************************************************************************
- * @ target        : local pointer on target thread.
- * @ ack_rsp_count : local pointer on responses counter.
- **************************************************************************************/
-void thread_set_req_ack( thread_t * target,
-                         uint32_t * ack_rsp_count );
-
-/***************************************************************************************
- * This function is used by the sched_handle_signal() function executed by the 
- * scheduler of a "target" thread to reset a "blocked not running" acknowledge request
- * in both the target thread descriptor, and in the target  thread scheduler.
- ***************************************************************************************
- * @ target    : local pointer on target thread.
- **************************************************************************************/
-void thread_reset_req_ack( thread_t * target );
-
-/***************************************************************************************
- * This function is used by the four sys_thread_cancel(), sys_thread_exit(),
- * sys_kill() and sys_exit() system calls to mark for delete a given thread. 
- * It set the THREAD_BLOCKED_GLOBAL bit and set the THREAD_FLAG_REQ_DELETE bit in the
- * thread descriptor identified by the <thread_xp> argument, to ask the scheduler 
- * to asynchronously delete the target thread, at the next scheduling point. 
- * The calling thread can run in any cluster, as it uses remote accesses.
- * This function makes a kernel panic if the target thread is the main thread,
- * because the main thread deletion will cause the process deletion, and a process
- * must be deleted by the parent process, running the wait function.
- * If the target thread is running in "attached" mode, and the <is_forced> argument
- * is false, this function implements the required sychronisation with the joining 
- * thread, blocking the killer thread until the pthread_join() syscall is executed
- * by the joining thread.
- ***************************************************************************************
- * @ thread_xp   : extended pointer on the target thread.
- * @ is_forced   : the deletion does not depends on the attached mode. 
- **************************************************************************************/
-void thread_delete_request( xptr_t  thread_xp,
-                            bool_t  is_forced );
-
-/***************************************************************************************
- * This function registers a blocking cause defined by the <cause> argument 
- * in a remote thread descriptor identified by the <thread_xp> argument.
- * We need an extended pointer, because this function can be called by another thread
- * than the target thread, executing the sys_kill() function.
- * WARNING : this function does not deschedule the target thread, and the descheduling
- * must be explicitely forced by a sched_yield().
- ***************************************************************************************
- * @ thread_xp   : extended pointer on remote thread descriptor.
- * @ cause       : mask defining the cause (one hot).
- **************************************************************************************/
-void thread_block( xptr_t   thread_xp,
-                   uint32_t cause );
-
-/***************************************************************************************
- * This function resets the bit identified by the <cause> argument in a remote
- * thread descriptor identified by the <thread_xp> argument.
+ * This function releases the physical memory allocated for a thread descriptor 
+ * in the local cluster. It can be used for both an user and a kernel thread.
+ * The physical memory dynamically allocated in the HEAP or MMAP zones by an user 
+ * thread will be released when the process is killed, and the page table flushed.
+ ***************************************************************************************
+ * @ thread  : pointer on the thread descriptor to release.  
+ **************************************************************************************/
+void thread_destroy( thread_t * thread );
+
+/***************************************************************************************
+ * This function defines the code of the thread executed when no other thread is 
+ * runnable for a given core. It try to force the core to the low-power state.
+ **************************************************************************************/
+void * thread_idle_func();
+
+/***************************************************************************************
+ * This function registers a child thread in the global list of attached 
+ * children threads of a parent thread.
+ * It does NOT take a lock, as this function is allways called by the parent thread.
+ ***************************************************************************************
+ * @ xp_parent : extended pointer on the parent thread descriptor.
+ * @ xp_child  : extended pointer on the child thread descriptor.
+ **************************************************************************************/
+void thread_child_parent_link( xptr_t  xp_parent,
+                               xptr_t  xp_child );
+
+/***************************************************************************************
+ * This function removes an user thread from the parent thread global list 
+ * of attached children threads. 
+ * It does take the lock, as this function can be called by the child thread.
+ * In this case, it uses the extended pointer on the parent thread contained 
+ * in the pthread_attr_t embedded in the child thread descriptor.
+ ***************************************************************************************
+ * @ xp_parent : extended pointer on the parent thread descriptor.
+ * @ xp_child  : extended pointer on the child thread descriptor.
+ **************************************************************************************/
+void thread_child_parent_unlink( xptr_t xp_parent,
+                                 xptr_t xp_child );
+
+
+/***************************************************************************************
+ * This function atomically set a signal in a thread descriptor.
+ ***************************************************************************************
+ * @ thread    : local pointer on target thread.
+ * @ mask      : mask on selected signal.
+ **************************************************************************************/
+inline void thread_set_signal( thread_t * thread,
+                               uint32_t   mask );
+
+/***************************************************************************************
+ * This function reset a signal in a thread descriptor.
+ ***************************************************************************************
+ * @ thread    : local pointer on target thread.
+ * @ mask      : mask on selected signal.
+ **************************************************************************************/
+inline void thread_reset_signal( thread_t * thread,
+                                 uint32_t   mask );
+
+/***************************************************************************************
+ * This function returns true if the calling thread is attached to its parent thread.
+ **************************************************************************************/
+inline bool_t thread_is_joinable();
+
+/***************************************************************************************
+ * This function returns true if the calling thread is not blocked.
+ **************************************************************************************/
+inline bool_t thread_is_runnable();
+
+/***************************************************************************************
+ * This function cheks if the calling thread can deschedule.
+ ***************************************************************************************
+ * @ returns true if no locks taken.
+ **************************************************************************************/
+inline bool_t thread_can_yield();
+
+/***************************************************************************************
+ * This function checks if the calling thread must be descheduled. 
+ ***************************************************************************************
+ * @ returns true if no locks taken, and elapsed time.
+ **************************************************************************************/
+bool_t thread_check_sched();
+
+/***************************************************************************************
+ * This function can be used by the calling thread to suicide.
+ * All locks must be previouly released.
+ * The scenario depends on the attached/detached flag :
+ * - if detached, it set the SIG_KILL signal in the "signals" bit_vector, registers
+ *   the BLOCKED_EXIT bit in the "blocked" bit_vector, and deschedule.
+ * - if attached, it simply set the BLOCKED_EXIT bit in the "blocked" bit vector
+ *   and deschedule. The SIG_KILL signal will be set by the parent thread when
+ *   executing the pthread_join().
+ ***************************************************************************************
+ * @ returns 0 if success / returns EINVAL if locks_count is not zero.
+ **************************************************************************************/
+error_t thread_exit();
+
+/***************************************************************************************  
+ * This function registers a blocking cause in the target thread "blocked" bit vector.
+ * Warning : this function does not deschedule the calling thread.
+ * The descheduling can be forced by a sched_yield(). 
+ ***************************************************************************************
+ * @ thread   : local pointer on target thread.
+ * @ cause    : mask defining the cause (one hot).
+ **************************************************************************************/
+void thread_block( thread_t * thread,
+                   uint32_t   cause );
+
+/***************************************************************************************  
+ * This function reset the bit identified by the cause argument in the "blocked"
+ * bit vector of a remote thread descriptor.
  * We need an extended pointer, because the client thread of an I/O operation on a
- * given device is generally not in the same cluster as the associated server thread.
- * WARNING : this function does not reschedule the remote thread.
+ * given device is not in the same cluster as the associated device descriptor.
+ * Warning : this function does not reschedule the remote thread. 
  * The scheduling can be forced by sending an IPI to the core running the remote thread.
  ***************************************************************************************
- * @ thread_xp   : extended pointer the remote thread.
- * @ cause       : mask defining the cause (one hot).
- * @ return non zero if the bit-vector was actually modified / return 0 otherwise
- **************************************************************************************/
-uint32_t thread_unblock( xptr_t   thread_xp,
-                         uint32_t cause );
-
-/***************************************************************************************
- * This function updates the calling thread user_time or kernel_time counters. 
- ***************************************************************************************
- * @ thread   : local pointer on target thread.
- * @ is_user  : update user time if true / update kernel time if false
- **************************************************************************************/
-void thread_time_update( thread_t * thread,
-                         bool_t     is_user );
-
-/***************************************************************************************
- * This function returns the extended pointer on a thread descriptor identified
- * by its thread identifier, and process identifier.
- * It can be called by any thread running in any cluster.
- ***************************************************************************************
- * @ pid     : process identifier.
- * @ trdid   : thread identifier.
- * @ return the extended pointer if thread found / return XPTR_NULL if not found.
- **************************************************************************************/
-xptr_t thread_get_xptr( pid_t    pid,
-                        trdid_t  trdid );
-
-/***************************************************************************************
- * This function checks that the thread identified by the <thread> argument does hold
- * any busylock (local or remote).
- * If the xlist of taken busylocks is not empty, it displays the set of taken locks,
- * and makes a kernel panic.  
- ***************************************************************************************
- * @ thread    : local pointer on target thread.
- * @ func_str  : faulty function name.
- **************************************************************************************/
-void thread_assert_can_yield( thread_t    * thread,
-                              const char  * func_str );
-
-/***************************************************************************************
- * This debug function display the list of busylocks (local or remote) 
- * currently owned by a the thread identified by the <thead_xp> argument.
- * The <string> argument is printed in header (can be the calling function name). 
- * WARNING : the DEBUG_BUSYLOCK parameter must be set in the kernel_config.h file.
- ***************************************************************************************
- * @ thread_xp  : extended pointer on target thread.
- * @ string     : defines the calling context.
- **************************************************************************************/
-void thread_display_busylocks( xptr_t       thread_xp,
-                               const char * string );
-
-
+ * @ thread   : extended pointer on the remote thread.
+ * @ cause    : mask defining the cause (one hot).
+ **************************************************************************************/
+void thread_unblock( xptr_t   thread,
+                     uint32_t cause );
+
+/***************************************************************************************  
+ * This function kills a target thread, identified by its local pointer.
+ * It is generally called by the local process_destroy() function.
+ * - it forces the global blocked bit in target thread descriptor.
+ * - it set the SIG_KILL signal in target thread.
+ * - it send an IPI_SCHED_REQUEST to the target thread core.
+ ***************************************************************************************
+ * @ thread   : local pointer on the target thread.
+ * @ returns 0 if success / returns EINVAL if locks_count is not zero.
+ **************************************************************************************/
+void thread_kill( thread_t * thread );
 
 #endif	/* _THREAD_H_ */
Index: trunk/kernel/kern/time.c
===================================================================
--- trunk/kernel/kern/time.c	(revision 1)
+++ trunk/kernel/kern/time.c	(revision 1)
@@ -0,0 +1,171 @@
+/*
+ * kern/time.c - thread time related management
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <thread.h>
+#include <task.h>
+#include <scheduler.h>
+#include <time.h>
+#include <list.h>
+#include <rt_timer.h>
+#include <kmagics.h>
+
+error_t alarm_wait(struct alarm_info_s *info, uint_t msec)
+{
+	register uint_t tm_now;
+	struct cpu_s *cpu;
+	struct alarm_s *alarm_mgr;
+	struct list_entry *iter;
+	struct alarm_info_s *current;
+	uint_t irq_state;
+
+	cpu       = current_cpu;
+	alarm_mgr = &cpu->alarm_mgr;
+
+	cpu_disable_all_irq(&irq_state);
+
+	tm_now          = cpu_get_ticks(cpu) * MSEC_PER_TICK;
+	info->signature = ALRM_INFO_ID;
+	info->tm_wakeup = tm_now + msec;
+
+	if(list_empty(&alarm_mgr->wait_queue))
+		list_add_first(&alarm_mgr->wait_queue, &info->list);
+	else
+	{
+		list_foreach_forward(&alarm_mgr->wait_queue, iter)
+		{
+			current = list_element(iter, struct alarm_info_s, list);
+      
+			if(info->tm_wakeup <= current->tm_wakeup) 
+			{
+				list_add_pred(iter, &info->list);
+				goto NEXT_TRAITMENT;
+			}
+		}
+		list_add_last(&alarm_mgr->wait_queue, &info->list);
+	}
+
+NEXT_TRAITMENT:
+	cpu_restore_irq(irq_state);
+	return 0;
+}
+
+void alarm_clock(struct alarm_s *alarm, uint_t ticks_nr)
+{
+	register uint_t tm_msec;
+	register struct list_entry *iter;
+	register struct alarm_info_s *info;
+  
+	tm_msec = ticks_nr * MSEC_PER_TICK;
+
+	list_foreach_forward(&alarm->wait_queue, iter)
+	{
+		info = list_element(iter, struct alarm_info_s, list);
+
+		assert((info->signature == ALRM_INFO_ID) && "Not an ALRM info object");
+
+		if(tm_msec < info->tm_wakeup)
+			break;
+    
+		list_unlink(iter);
+		event_send(info->event, current_cpu->gid);
+	}
+}
+
+error_t alarm_manager_init(struct alarm_s *alarm)
+{
+	list_root_init(&alarm->wait_queue);
+	return 0;
+}
+
+
+#if CONFIG_THREAD_TIME_STAT
+
+inline void tm_sleep_compute(struct thread_s *thread)
+{
+	uint_t tm_now;
+
+	if(thread->type == TH_IDLE)
+		return;
+
+	rt_timer_read(&tm_now);
+	thread->info.tm_sleep += (tm_now - thread->info.tm_tmp);
+	thread->info.tm_tmp    = tm_now;
+}
+
+inline void tm_usr_compute(struct thread_s *thread)
+{ 
+	uint_t tm_now;
+
+	rt_timer_read(&tm_now);
+	thread->info.tm_usr += (tm_now - thread->info.tm_tmp);
+	thread->info.tm_tmp  = tm_now;
+}
+
+inline void tm_sys_compute(struct thread_s *thread)
+{ 
+	uint_t tm_now;
+
+	rt_timer_read(&tm_now);
+	thread->info.tm_sys += (tm_now - thread->info.tm_tmp);
+	thread->info.tm_tmp  = tm_now;
+}
+
+inline void tm_wait_compute(struct thread_s *thread)
+{
+	uint_t tm_now;
+
+	if(thread->type == TH_IDLE)
+		return;
+
+	rt_timer_read(&tm_now);
+	thread->info.tm_wait += (tm_now - thread->info.tm_tmp);
+	thread->info.tm_tmp   = tm_now;
+	thread->info.tm_exec  = tm_now;
+}
+
+inline void tm_exit_compute(struct thread_s *thread)
+{
+	uint_t tm_now;
+  
+	rt_timer_read(&tm_now);
+	thread->info.tm_sys += tm_now - thread->info.tm_tmp;
+	thread->info.tm_dead = tm_now;
+}
+
+inline void tm_born_compute(struct thread_s *thread)
+{
+	uint_t tm_now;
+  
+	rt_timer_read(&tm_now);
+	thread->info.tm_born = tm_now;
+	thread->info.tm_tmp  = tm_now;
+	thread->info.tm_exec = tm_now;
+}
+
+inline void tm_create_compute(struct thread_s *thread)
+{
+	rt_timer_read(&thread->info.tm_create);
+}
+
+
+#endif	/* CONFIG_THREAD_TIME_STAT */
Index: trunk/kernel/kern/time.h
===================================================================
--- trunk/kernel/kern/time.h	(revision 1)
+++ trunk/kernel/kern/time.h	(revision 1)
@@ -0,0 +1,110 @@
+/*
+ * time.h: thread time related management
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _TIME_H_
+#define _TIME_H_
+
+#include <types.h>
+#include <list.h>
+#include <device.h>
+
+struct event_s;
+
+struct alarm_info_s 
+{
+	uint_t signature;
+
+	/* Public members */
+	struct event_s *event;
+
+	/* Private members */
+	uint_t tm_wakeup;
+	struct list_entry list;
+};
+
+struct alarm_s
+{ 
+	struct list_entry wait_queue;
+};
+
+
+struct timeb {
+	time_t         time;
+	unsigned short millitm;
+	short          timezone;
+	short          dstflag;
+};
+
+struct timeval {
+	clock_t tv_sec;    /* secondes */
+	clock_t tv_usec;   /* microsecondes */
+};
+
+struct timezone {
+	int tz_minuteswest;     /* minutes west of Greenwich */
+	int tz_dsttime;         /* type of DST correction */
+};
+
+
+struct tms 
+{
+       clock_t tms_utime;  /* user time */
+       clock_t tms_stime;  /* system time */
+       clock_t tms_cutime; /* user time of children */
+       clock_t tms_cstime; /* system time of children */
+};
+
+
+error_t alarm_manager_init(struct alarm_s *alarm);
+error_t alarm_wait(struct alarm_info_s *info, uint_t msec);
+
+void alarm_clock(struct alarm_s *alarm, uint_t ticks_nr);
+
+int sys_clock (uint64_t *val);
+int sys_alarm (unsigned nb_sec);
+int sys_ftime (struct timeb *utime);
+int sys_times(struct tms *utms);
+int sys_gettimeofday(struct timeval *tv, struct timezone *tz);
+
+#if CONFIG_THREAD_TIME_STAT
+struct thread_s;
+inline void tm_sleep_compute(struct thread_s *thread);
+inline void tm_usr_compute(struct thread_s *thread);
+inline void tm_sys_compute(struct thread_s *thread);
+inline void tm_wait_compute(struct thread_s *thread);
+inline void tm_exit_compute(struct thread_s *thread);
+inline void tm_born_compute(struct thread_s *thread);
+inline void tm_create_compute(struct thread_s *thread);
+
+#else
+
+#define tm_sleep_compute(thread)
+#define tm_usr_compute(thread)
+#define tm_sys_compute(thread)
+#define tm_wait_compute(thread)
+#define tm_exit_compute(thread)
+#define tm_born_compute(thread)
+#define tm_create_compute(thread)
+
+#endif	/* CONFIG_SCHED_STAT */
+
+#endif	/* _TIME_H_ */
Index: trunk/kernel/kernel.ld
===================================================================
--- trunk/kernel/kernel.ld	(revision 1)
+++ trunk/kernel/kernel.ld	(revision 1)
@@ -0,0 +1,33 @@
+/**********************************************************************************************
+ * This is the linker script for the ALMOS-MK kernel.
+ * It describes the memory layout for the "kernel.elf" binary file.
+ *********************************************************************************************/
+
+/* define the kernel code base address */
+
+kernel_base = 0x400000;
+
+/* Set the entry point of the boot-loader (e_entry field in the "boot.elf" file header) */ 
+
+ENTRY(kernel_init)
+
+/* Describe how to group the sections */
+
+SECTIONS
+{
+    . = kernel_base;
+    .text :
+    {
+        *(.text)
+        *(.rodata*)
+    }
+    . = ALIGN(0x1000);
+    .data :
+    {
+        *(.data*)
+    }
+    .bss :
+    {
+        *(.bss)
+    }
+}
Index: trunk/kernel/ksh/cat.c
===================================================================
--- trunk/kernel/ksh/cat.c	(revision 1)
+++ trunk/kernel/ksh/cat.c	(revision 1)
@@ -0,0 +1,71 @@
+/*
+	This file is part of MutekP.
+	
+	MutekP is free software; you can redistribute it and/or modify it
+	under the terms of the GNU General Public License as published by
+	the Free Software Foundation; either version 2 of the License, or
+	(at your option) any later version.
+	
+	MutekP is distributed in the hope that it will be useful, but
+	WITHOUT ANY WARRANTY; without even the implied warranty of
+	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+	General Public License for more details.
+	
+	You should have received a copy of the GNU General Public License
+	along with MutekP; if not, write to the Free Software Foundation,
+	Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+	
+	UPMC / LIP6 / SOC (c) 2008
+	Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <stdint.h>
+#include <string.h>
+#include <sys-vfs.h>
+#include <kminiShell.h>
+ 
+error_t cat_func(void *param)
+{
+#if 1
+	struct ku_obj ku_buff;
+	error_t err;
+	ssize_t size;
+	uint32_t argc;
+	uint32_t i;
+	struct vfs_file_s file;
+	ms_args_t *args;
+	uint_t count;
+
+	args  = (ms_args_t*) param;
+	argc = args->argc;
+	err = 0;
+	
+	for(i=1; i< argc; i++)
+	{
+		
+		KK_BUFF(ku_buff, args->argv[i]);
+		if((err=vfs_open(ms_n_cwd, &ku_buff,VFS_O_RDONLY,0, &file)))
+			return err;
+		
+		KK_SZ_BUFF(ku_buff, buffer, BUFFER_SIZE);
+		while((size = vfs_read(&file, &ku_buff)) > 0)
+		{ 
+			ksh_write(buffer, size);
+			//if((ch=getChar()) == 'q') break;
+		}
+		
+		err = vfs_close(&file, &count);
+	 
+		if(err)
+			printk(WARNING, "WARNING: %s: failed to close file at iteration %d, err %d\n", __FUNCTION__, i, err);
+
+		
+		if(size < 0) return size;
+	}
+
+	return 0;
+#else
+	return ENOSYS;
+#endif
+}
+
Index: trunk/kernel/ksh/cd.c
===================================================================
--- trunk/kernel/ksh/cd.c	(revision 1)
+++ trunk/kernel/ksh/cd.c	(revision 1)
@@ -0,0 +1,40 @@
+/*
+	This file is part of MutekP.
+	
+	MutekP is free software; you can redistribute it and/or modify it
+	under the terms of the GNU General Public License as published by
+	the Free Software Foundation; either version 2 of the License, or
+	(at your option) any later version.
+	
+	MutekP is distributed in the hope that it will be useful, but
+	WITHOUT ANY WARRANTY; without even the implied warranty of
+	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+	General Public License for more details.
+	
+	You should have received a copy of the GNU General Public License
+	along with MutekP; if not, write to the Free Software Foundation,
+	Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+	
+	UPMC / LIP6 / SOC (c) 2008
+	Copyright Ghassan Almaless <ghassan.almaless@gmail.com>
+*/
+
+#include <kminiShell.h>
+
+error_t cd_func(void *param)
+{
+	ms_args_t *args ;
+	char * path_name;
+	struct ku_obj ku_path;
+	
+	args  = (ms_args_t *) param;
+
+	if(args->argc == 1)
+		path_name = "/";
+	else
+		path_name = args->argv[1];
+
+	
+	KK_BUFF(ku_path, path_name);
+	return vfs_chdir(&ku_path, ms_n_cwd);
+}
